/*  Copyright (C) 2007 Faculdade de Ciências e Tecnologia 
 *                     Universidade Nova de Lisboa
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BUFFER_H_
#define BUFFER_H_

#include <sys/types.h>

struct buffer
{
	void *data;
	size_t size;

	size_t max_size;

	void *user_data;

	int (*flush_func)(void *data, size_t size, void *user_data);
};

extern void buffer_init(struct buffer *, size_t, void *, 
			int (*)(void *, size_t, void *));
extern void buffer_free(struct buffer *);

extern int buffer_flush(struct buffer *);
extern int buffer_write(struct buffer *, void *, size_t);

#endif
